module keyobs;
//keyobs(dx4d)
import dx4d;
//キー監視
class Keyobs {
static :
	private char[256] State;
	private int[256] PrevState;
	void check() {
		for(int i; i < 256; i++){
			if (State[i]) {
				PrevState[i]++;
			} else {
				PrevState[i] = State[i];
			}
		}
		dx_GetHitKeyStateAll(State.ptr);
	}
	//ステータス(押している間ずっと)
	bool state(int KeyId){
		return (State[KeyId] == 1);
	}
	//トリガー(押した瞬間のみ)
	bool trigger(int KeyId) {
		return ((PrevState[KeyId] == 0)&&(State[KeyId] != 0));
	}
	//リリース(離した瞬間のみ)
	bool release(int KeyId) {
		return ((PrevState[KeyId] != 0)&&(State[KeyId] == 0));
	}
	//ホールド(押し続けている間、一定間隔で)
	bool hold(int KeyId, uint Interval) {
		return (PrevState[KeyId] % Interval == 1);
	}
}
